% Cross-validation strategy: with Null reference 

%% Mohammad Rezaei
% Date: 9.10.2018

clc;
close all;
clearvars;

dataset = 'dim032'; % it is also the fodler that s1 dataset is in
folder = '..\experiments_results\dim032\dim032_rs\';
clus_method = 'rs';

dataset_null = 'dim032_null'; % it is also the fodler that s1 dataset is in
folder_null = '..\experiments_results\dim032\dim032_null_rs\';
clus_method = 'rs';


n1 = 2; % the range for the number of clusters
n2 = 25;
nSubsets = 100;
th_lastLocalMax = 0.2;

%% read full dataset
% fp = fopen(strcat('dataset\',dataset, '\', dataset, '.txt'), 'rb');
% data = textscan(fp, '%d %d');
% data = cell2mat(data);
% data = double(data);
% fclose(fp);

data = dlmread(strcat('dataset\',dataset, '\', dataset, '.txt'));

%% read full null dataset
% fp = fopen(strcat('dataset\',dataset_null, '\', dataset_null, '.txt'), 'rb');
% data_null = textscan(fp, '%d %d');
% data_null = cell2mat(data_null);
% data_null = double(data_null);
% fclose(fp);

data_null = dlmread(strcat('dataset\',dataset_null, '\', dataset_null, '.txt'));

%% average similarity for each number of clusters
[RI_avg, ARI_avg, NMI_avg, NVD_avg, PSI_avg, CI_avg, CSI_avg] = deal(zeros(1,n2-n1+1));
[RI_avg_n, ARI_avg_n, NMI_avg_n, NVD_avg_n, PSI_avg_n, CI_avg_n, CSI_avg_n] = deal(zeros(1,n2-n1+1));

ii = 1;
for i = n1:n2
    disp(i);
    
    % read partition of full dataset
    pFullset = readPartition(strcat(folder, dataset, '-', clus_method, '-', num2str(i), '.pa'));
    
    % calculate centroids
    %cFullset = calcCentroidsFromIDX(data, pFullset);
    
    for j = 1:nSubsets
        if (i==17 && j==12)
            disp(j);
        end
        % read partition of the subset j
        if j < 10 
            t = strcat('0', num2str(j));
        else
            t = num2str(j);
        end
        pSubset = readPartition(strcat(folder, dataset, '-', t, '-', clus_method, '-', num2str(i), '.pa'));
        
        % get corresponding data for the subset and calculate centroids
        idx = readIdxFile(strcat('dataset\', dataset, '\', 'idx', '-', t, '.txt'));
        dataSubset = data(idx, :);
        cSubset = calcCentroidsFromIDX(dataSubset, pSubset);
        
        % calculate similarity
        pFullset_shared = pFullset(idx); % the similarity between two clusterings is calcuylated based on the shared objects between fullset and subset 
        
        % calculate centroids
        cFullset = calcCentroidsFromIDX(dataSubset, pFullset_shared); % we can't calculate cFullset from full dataset because in the shared data, we might miss some clusters. If we use full data to calculate the centroids, then the number of centroids might mismatch with the number of clusters

        [RI, ARI, NMI, NVD, PSI] = getExternalIndices(pFullset_shared', pSubset'); NVD = 1-NVD;
        [CI, CSI] = getCI_CSI(cFullset, cSubset, pFullset_shared', pSubset'); CI = 1-double(CI)/i;
        RI_avg(ii) = RI_avg(ii) + RI;
        ARI_avg(ii) = ARI_avg(ii) + ARI;
        NMI_avg(ii) = NMI_avg(ii) + NMI;
        NVD_avg(ii) = NVD_avg(ii) + NVD;
        PSI_avg(ii) = PSI_avg(ii) + PSI;
        CI_avg(ii) = CI_avg(ii) + CI;
        CSI_avg(ii) = CSI_avg(ii) + CSI;
    end
    
    RI_avg(ii) = RI_avg(ii) / nSubsets;
    ARI_avg(ii) = ARI_avg(ii) / nSubsets;
    NMI_avg(ii) = NMI_avg(ii) / nSubsets;
    NVD_avg(ii) = NVD_avg(ii) / nSubsets;
    PSI_avg(ii) = PSI_avg(ii) / nSubsets;
    CI_avg(ii) = CI_avg(ii) / nSubsets;
    CSI_avg(ii) = CSI_avg(ii) / nSubsets;
    
    %---------- same for null reference  -------------%
    % read partition of full dataset
    pFullset = readPartition(strcat(folder_null, dataset_null, '-', clus_method, '-', num2str(i), '.pa'));
    
    % calculate centroids
    %cFullset = calcCentroidsFromIDX(data_null, pFullset);
    
    for j = 1:nSubsets
        % read partition of the subset j
        if j < 10 
            t = strcat('0', num2str(j));
        else
            t = num2str(j);
        end
        pSubset = readPartition(strcat(folder_null, dataset_null, '-', t, '-', clus_method, '-', num2str(i), '.pa'));
        
        % get corresponding data for the subset and calculate centroids
        idx = readIdxFile(strcat('dataset\', dataset_null, '\', 'idx', '-', t, '.txt'));
        dataSubset = data_null(idx, :);
        cSubset = calcCentroidsFromIDX(dataSubset, pSubset);
        
        % calculate similarity
        pFullset_shared = pFullset(idx); % the similarity between two clusterings is calcuylated based on the shared objects between fullset and subset 
        
        % calculate centroids
        cFullset = calcCentroidsFromIDX(dataSubset, pFullset_shared); % we can't calculate cFullset from full dataset because in the shared data, we might miss some clusters. If we use full data to calculate the centroids, then the number of centroids might mismatch with the number of clusters
        
        [RI, ARI, NMI, NVD, PSI] = getExternalIndices(pFullset_shared', pSubset'); NVD = 1-NVD;
        [CI, CSI] = getCI_CSI(cFullset, cSubset, pFullset_shared', pSubset'); CI = 1-double(CI)/i;
        RI_avg_n(ii) = RI_avg_n(ii) + RI;
        ARI_avg_n(ii) = ARI_avg_n(ii) + ARI;
        NMI_avg_n(ii) = NMI_avg_n(ii) + NMI;
        NVD_avg_n(ii) = NVD_avg_n(ii) + NVD;
        PSI_avg_n(ii) = PSI_avg_n(ii) + PSI;
        CI_avg_n(ii) = CI_avg_n(ii) + CI;
        CSI_avg_n(ii) = CSI_avg_n(ii) + CSI;
    end
    
    RI_avg_n(ii) = RI_avg_n(ii) / nSubsets;
    ARI_avg_n(ii) = ARI_avg_n(ii) / nSubsets;
    NMI_avg_n(ii) = NMI_avg_n(ii) / nSubsets;
    NVD_avg_n(ii) = NVD_avg_n(ii) / nSubsets;
    PSI_avg_n(ii) = PSI_avg_n(ii) / nSubsets;
    CI_avg_n(ii) = CI_avg_n(ii) / nSubsets;
    CSI_avg_n(ii) = CSI_avg_n(ii) / nSubsets;
    
    ii = ii + 1;
end

% plot index values when number of clusters varies
plot([n1:n2], PSI_avg-PSI_avg_n);
axis([n1 n2 0 1]);

% global maximum
[v k_RI] = max(RI_avg-RI_avg_n);k_RI=k_RI+n1-1;
[v k_ARI] = max(ARI_avg-ARI_avg_n);k_ARI=k_ARI+n1-1;
[v k_NMI] = max(NMI_avg-NMI_avg_n);k_NMI=k_NMI+n1-1;
[v k_PSI] = max(PSI_avg-PSI_avg_n);k_PSI=k_PSI+n1-1;
[v k_NVD] = max(NVD_avg-NVD_avg_n);k_NVD=k_NVD+n1-1;
[v k_CSI] = max(CSI_avg-CSI_avg_n);k_CSI=k_CSI+n1-1;
[v k_CI] = max(CI_avg-CI_avg_n);k_CI=k_CI+n1-1;

% last local maximum
k_RI_llm = lastLocalMax(RI_avg-RI_avg_n, th_lastLocalMax, n1);
k_ARI_llm = lastLocalMax(ARI_avg-ARI_avg_n, th_lastLocalMax, n1);
k_NMI_llm = lastLocalMax(NMI_avg-NMI_avg_n, th_lastLocalMax, n1);
k_PSI_llm = lastLocalMax(PSI_avg-PSI_avg_n, th_lastLocalMax, n1);
k_NVD_llm = lastLocalMax(NVD_avg-NVD_avg_n, th_lastLocalMax, n1);
k_CSI_llm = lastLocalMax(CSI_avg-CSI_avg_n, th_lastLocalMax, n1);
k_CI_llm = lastLocalMax(CI_avg-CI_avg_n, th_lastLocalMax, n1);

% global maximum and last local maximum
[k_PSI k_PSI_llm]
[k_PSI k_PSI_llm]