% Cross-validation strategy for randomized algorithm
% An algorithm (random swap) has been ap[plied N times to a dataset

%% Mohammad Rezaei
% Date: 9.10.2018

clc;
close all;
clearvars;

dataset = 'dim032'; % it is also the fodler that s1 dataset is in
folder = '..\experiments_results\dim032\dim032_rs_ra1000\';
clus_method = 'rs';
n1 = 2; % the range for the number of clusters
n2 = 25;
nRepeat = 50;
th_lastLocalMax = 0.9;

%% read full dataset
% fp = fopen(strcat('dataset\',dataset, '\', dataset, '.txt'), 'rb');
% data = textscan(fp, '%d %d');
% data = cell2mat(data);
% data = double(data);
% fclose(fp);
data = dlmread(strcat('dataset\',dataset, '\', dataset, '.txt'));

nComparisons = nRepeat*(nRepeat-1)/2;
nData = size(data,1);

%% average similarity for each number of clusters
PSI_avg = zeros(1,n2-n1+1);
ii = 1;
for i = n1:n2
    disp(i);
    
    %--------- read all partitions when number of clusters is i
    pAll = zeros(nData,nRepeat);
    for j = 1:nRepeat
        if j < 10 
            t = strcat('0', num2str(j));
        else
            t = num2str(j);
        end

        p = readPartition(strcat(folder, dataset, '-', t, '-', clus_method, '-', num2str(i), '.pa'));
        pAll(:,j) = p;
    end
    %-----------------------------------------------------------

    
    for j = 1:nRepeat
        if j < 10 
            t = strcat('0', num2str(j));
        else
            t = num2str(j);
        end
        
        % read partition j
        p1 = pAll(:,j);
        
        for l = j+1:nRepeat
            if l < 10 
                s = strcat('0', num2str(l));
            else
                s = num2str(l);
            end
             % read partition l
             p2 = pAll(:,l);
             
             PSI = getPSI(p1', p2');
             PSI_avg(ii) = PSI_avg(ii) + PSI;
             
        end
    end
    
    PSI_avg(ii) = PSI_avg(ii) / nComparisons;
    
    ii = ii + 1;
end

% plot index values when number of clusters varies
plot([n1:n2], PSI_avg);
axis([n1 n2 0.6 1]);

[v, k_PSI] = max(PSI_avg);k_PSI=k_PSI+n1-1;

% last local maximum
k_PSI_llm = lastLocalMax(PSI_avg, th_lastLocalMax, n1);

[k_PSI k_PSI_llm]
[k_PSI k_PSI_llm]