% Solving number of clusters using internal indices 

%% Mohammad Rezaei
% Date: 13.10.2018

clc;
close all;
clearvars;

dataset = 'dim032'; % it is also the fodler that s1 dataset is in
folder = '..\experiments_results\dim032\dim032_rs\';
clus_method = 'rs';
k1 = 2; % the range for the number of clusters
k2 = 16;
nSubsets = 100;

data = dlmread(strcat('dataset\',dataset, '\', dataset, '.txt'));
[n, d] = size(data);

%% get data labels from file
clust = zeros(n,k2-k1+1);
ii = 1;
for i = k1:k2
    idx = readPartition(strcat(folder, dataset, '-', clus_method, '-', num2str(i), '.pa'));
    clust(:,ii) = idx;
    
    ii = ii + 1;
end
    
%% different internal indices
evaCH = evalclusters(data, clust, 'CalinskiHarabasz');
CH_k = evaCH.OptimalK;
CHvals = evaCH.CriterionValues;

WBvals = myEvalClusters(data, clust, 'WB');
[v WB_k] = min(WBvals); WB_k = WB_k + k1-1;

evaSIL = evalclusters(data, clust, 'Silhouette');
SIL_k = evaSIL.OptimalK;
SILvals = evaSIL.CriterionValues;

[CH_k SIL_k WB_k]
[CH_k SIL_k WB_k]
