% clustering data for randomized algorithm
% apply random swap to a dataset 100 times for given range of number of
% clusters


%% Mohammad Rezaei
% Date: 8.10.2018

clc;
close all;
clearvars;

addpath ..\..\code\clalg\mykmeans
addpath ..\..\code\clalg\random_swap

dataset = 'a1'; % it is also the fodler that s1 dataset is in
folder = '..\experiments_results\a1\a1_rs_ra100\';
clus_method = 'rs';
n1 = 10; % the range for the number of clusters
n2 = 30;
nRepeat = 50;

%% read full dataset
fp = fopen(strcat('dataset\',dataset, '\', dataset, '.txt'), 'rb');
data = textscan(fp, '%d %d');
data = cell2mat(data);
data = double(data);
fclose(fp);

N = size(data,1);

%% clustering 
ii = 1;
for i = n1:n2
    disp(i);
    
    for j = 1:nRepeat
        % read partition of the subset j
        if j < 10 
            t = strcat('0', num2str(j));
        else
            t = num2str(j);
        end
        
        [idx, C, sumD, D, elapsed_time, n_repeat] = randomSwap(data, i, 100, [], 0);
        
        filename = strcat(folder, dataset, '-', t, '-', clus_method, '-', num2str(i), '.pa');
        
        fp = fopen(filename, 'wb');
        fprintf(fp, 'VQ PARTITIONING 2.0\n');
        fprintf(fp, '%d\n', i);
        fprintf(fp, '%d\n', N);
        fprintf(fp, '-------------------------------------\n');
        
        for l=1:N
            fprintf(fp, '%d\n', idx(l));
        end
        fclose(fp);
    end
end
