% mapping centroids of one clustering to another for Centroid Index
function mapx = mapCentroids(c1,c2)

n1 = size(c1, 1); % number of centroids in clustering 1
n2 = size(c2, 1); % number of centroids in clustering 2

d = size(c1, 2); % dimensioanlity of data

mapx = ones(n1,1);
% nearest neighbor mapping
for i = 1:n1
    p1 = c1(i,:);
    k = 1;
    dmin = flintmax;
    for j = 1:n2
        p2 = c2(j,:);
        t = norm(p1-p2);
        if ( t < dmin )
            dmin = t;
            k = j;
        end
    end
    
    mapx(i) = k;
end