
function vals = myEvalClusters(data, clust, internalIndex)

[n, d] = size(data);
[nx, kRange] = size(clust);
mean_data = mean(data);
vals = zeros(1, kRange);

for ii = 1:kRange
    idx = clust(:,ii);
    m1 = unique(idx);
    k = length(m1);
    min1 = min(idx);
    
    if ( min1 == 0 )
        idx = idx + 1;
    end
    K1 = max(idx); 
    
    % if empty clusters, just fix it
    if ( k ~= K1 )
        for i=1:k
            idx(idx==m1(i)) = i;
        end
    end
    
    % calculate centroids
    centroids = calcCentroidsFromIDX(data, idx);
    
    % SSW
    SSW = 0;
    for i=1:n
        j = idx(i);
        SSW = SSW + norm(data(i,:) - centroids(j,:))^2;
    end
    
    % SSB
    SSB = 0;
    
    for i=1:k
        ni = length(find(idx==i));
        SSB = SSB + ni * ((norm(centroids(i,:) - mean_data))^2);
    end
    
    vals(ii) = k*SSW/SSB;
    
end


end