function [e12] = pairPartitionsExpected(idx1, idx2)

% expected value of index (PS3)

n = length(idx1);
K1 = max(idx1); % number of clusters in clustering 1
K2 = max(idx2); % number of clusters in clustering 2
K = min(K1, K2);

cluster_size1 = [];
for ( j = 1:K1 )
    nj = length(find(idx1 == j)); 
    cluster_size1 = [cluster_size1 nj];
end

cluster_size2 = [];
for ( j = 1:K2 )
    nj = length(find(idx2 == j)); 
    cluster_size2 = [cluster_size2 nj];
end

cluster_size1 = sort(cluster_size1,'descend');
cluster_size2 = sort(cluster_size2,'descend');

e12 = 0;
for ( i = 1:K )
   e12 = e12 + (cluster_size1(i)*cluster_size2(i))/max(cluster_size1(i),cluster_size2(i));
   % e12 = e12 + (cluster_size1(i)*cluster_size2(i))/(cluster_size1(i)+cluster_size2(i)-cluster_size1(i)*cluster_size2(i)/n); % jaccard instead of BB
end

e12 = e12 / n;
