function [s12] = pairPartitionsSimilarity(idx1, idx2)

% similarity of two clusterings (PS3)

n = length(idx1);
K1 = max(idx1); % number of clusters in clustering 1
K2 = max(idx2); % number of clusters in clustering 2

%% match clusters using Hungarian algorithm
% find weights of links
weightsTable = ones(K1, K2);
for ( i = 1:K1 )
    idx_temp1 = find(idx1 == i); 
    cnt1= length(idx_temp1);
    labels2 = idx2(idx_temp1);
    for ( j = 1:K2 )
        idx_temp2 = find(labels2 == j);
        if ( ~isempty(idx_temp2) )
            shared_temp= length(idx_temp2);
            cnt2 = length(find(idx2 == j));
            weightsTable(i,j) = 1- shared_temp/max(cnt1, cnt2); % convert similarity to distance
            %weightsTable(i,j) = 1- shared_temp/(cnt1+cnt2-shared_temp); % convert similarity to distance using Jaccard instead of BB
        end
    end
end

[Matching,Costs] = Hungarian(weightsTable);



%%
s12 = 0;
temp1 = idx1;
temp2 = idx2;
for ( i = 1:K1 )
    % find a pair cluster with biggest match
    j = find(Matching(i,:)==1);
    
    if ( isempty(j) )
        continue;
    end
    
    s12 = s12 + 1 - weightsTable(i,j);
    
end